---
title: ':not()'
slug: 'Web/CSS/:not'
tags:
  - ':not()'
  - CSS
  - Layout
  - Negation
  - Pseudo-class
  - Reference
  - Selector
  - Web
---
<div>{{CSSRef}}</div>

<p>The <strong><code>:not()</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-class</a> represents elements that do not match a list of selectors. Since it prevents specific items from being selected, it is known as the <em>negation pseudo-class</em>.</p>

<pre class="brush: css no-line-numbers notranslate">/* Selects any element that is NOT a paragraph */
:not(p) {
  color: blue;
}</pre>

<p>The <code>:not()</code> pseudo-class has a number of <a href="/en-US/docs/Web/CSS/:not#Description">quirks, tricks, and unexpected results</a> that you should be aware of before using it.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>:not()</code> pseudo-class requires a comma-separated list of one or more selectors as its argument. The list must not contain another negation selector or a <a href="/en-US/docs/Web/CSS/Pseudo-elements">pseudo-element</a>.</p>

<div class="warning">
<p>The ability to list more than one selector is experimental and not yet widely supported.</p>
</div>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Description">Description</h2>

<p>There are several unusual effects and outcomes when using <code>:not()</code> that you should keep in mind when using it:</p>

<ul>
 <li>The <code>:not</code> pseudo-class may not be nested, which means that <code>:not(:not(...))</code> is invalid.</li>
 <li>Useless selectors can be written using this pseudo-class. For example, <code>:not(*)</code> matches any element which is not an element, which is obviously nonsense, so the accompanying rule will never be applied.</li>
 <li>This pseudo-class can increase the <a href="/en-US/docs/Web/CSS/Specificity">specificity</a> of a rule. For example, <code>#foo:not(#bar)</code> will match the same element as the simpler <code>#foo</code>, but has a higher specificity.</li>
 <li><code>:not(.foo)</code> will match anything that isn't <code>.foo</code>, <em>including {{HTMLElement("html")}} and {{HTMLElement("body")}}.</em></li>
 <li>This selector only applies to one element; you cannot use it to exclude all ancestors. For instance, <code>body :not(table) a</code> will still apply to links inside of a table, since {{HTMLElement("tr")}} will match with the <code>:not()</code> part of the selector.</li>
 <li>Using two selectors at the same time will not work. For example, <code>:not(.foo,bar)</code> is invalid. Instead, <code>:not(.foo):not(.bar)</code> should be used.</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_set_of_not_examples">Basic set of :not() examples</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;p&gt;I am a paragraph.&lt;/p&gt;
&lt;p class="fancy"&gt;I am so very fancy!&lt;/p&gt;
&lt;div&gt;I am NOT a paragraph.&lt;/div&gt;
&lt;h2&gt;
  &lt;span class="foo"&gt;foo inside h2&lt;/span&gt;
  &lt;span class="bar"&gt;bar inside h2&lt;/span&gt;
&lt;/h2&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">.fancy {
  text-shadow: 2px 2px 3px gold;
}

/* &lt;p&gt; elements that are not in the class `.fancy` */
p:not(.fancy) {
  color: green;
}

/* Elements that are not &lt;p&gt; elements */
body :not(p) {
  text-decoration: underline;
}

/* Elements that are not &lt;div&gt; and not &lt;span&gt; elements */
body :not(div):not(span) {
  font-weight: bold;
}

/* Elements that are not &lt;div&gt;s or `.fancy` */
/* Note that this syntax is not well supported yet. */
body :not(div, .fancy) {
  text-decoration: overline underline;
}

/* Elements inside an &lt;h2&gt; that aren't a &lt;span&gt; with a class of foo. */
/* Complex selectors such as an element with a class are not well supported yet. */
h2 :not(span.foo) {
  color: red;
}
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample('Basic_set_of_not_examples', '100%', 320)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Selectors', '#negation', ':not()')}}</td>
   <td>{{Spec2('CSS4 Selectors')}}</td>
   <td>Extends its argument to allow some non-simple selectors.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Selectors', '#negation', ':not()')}}</td>
   <td>{{Spec2('CSS3 Selectors')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("css.selectors.not")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/CSS/Pseudo-classes">Pseudo-classes</a></li>
 <li><a href="/en-US/docs/Learn/CSS/Building_blocks/Selectors/Pseudo-classes_and_pseudo-elements">Pseudo-classes and pseudo-elements</a></li>
 <li>Related CSS pseudo-classes:
  <ul>
   <li>{{cssxref(":has", ":has()")}}</li>
   <li>{{cssxref(":is", ":is()")}}</li>
   <li>{{cssxref(":where", ":where()")}}</li>
  </ul>
 </li>
</ul>
</div>
